/*
 * linux/arch/arm/drivers/block/adfs.h
 *
 * Copyright (c) 1996 Russell King.
 */

/*
 * Disc record size
 */
#define RECSIZE 60

/*
 * Disc record
 */
struct disc_record {
    unsigned char  log2secsize;
    unsigned char  secspertrack;
    unsigned char  heads;
    unsigned char  density;
    unsigned char  idlen;
    unsigned char  log2bpmb;
    unsigned char  skew;
    unsigned char  bootoption;
    unsigned char  lowsector;
    unsigned char  nzones;
    unsigned short zone_spare;
    unsigned long  root;
    unsigned long  disc_size;
    unsigned short disc_id;
    unsigned char  disc_name[10];
    unsigned long  disc_type;
    unsigned long  disc_size_high;
    unsigned char  log2sharesize:4;
    unsigned char  unused:4;
    unsigned char  big_flag:1;
};

struct riscix_part {
    unsigned long  start;
    unsigned long  length;
    unsigned long  one;
    char name[16];
};

struct riscix_record {
    unsigned long  magic;
    unsigned long  date;
    struct riscix_part part[8];
};

#define RISCIX_MAGIC	(0x4a657320)

/*
 * Partition types. (Oh for reusability)
 */
#define PARTITION_RISCIX_MFM 1
#define PARTITION_RISCIX_SCSI 2

/*
 * New-directory disks have a separate attributes byte - this is the bit mask.
 */
#define OBJ_OWNREAD	1
#define OBJ_OWNWRITE	2
#define OBJ_LOCKED	4
#define OBJ_DIRECTORY	8
#define OBJ_EXECUTE	16
#define OBJ_PUBREAD	32
#define OBJ_PUBWRITE	64

/*
 * Offset in bytes of the boot block on the disk.
 */
#define BOOT_SECTOR_ADDRESS 0xc00
